Index: branches/SHM-upgrade/cfg/encoder_intra_scalable.cfg
===================================================================
--- branches/SHM-upgrade/cfg/encoder_intra_scalable.cfg	(revision 989)
+++ branches/SHM-upgrade/cfg/encoder_intra_scalable.cfg	(revision 992)
@@ -5,7 +5,9 @@
 #======== Profile ================
 NumProfileTierLevel           : 3
-Profile0                      : scalable-main      #Profile for the whole bitstream
-Profile1                      : main               #Profile for the base layer --- this will be ignored when BL is not HEVC
-Profile2                      : scalable-main      #Profile for the enhancement layer
+Profile0                      : main                # Profile for BL (NOTE01: this profile applies to whole layers but only BL is outputted)
+                                                    #                (NOTE02: this profile has no effect when NonHEVCBase is set to 1)
+Profile1                      : main                # Profile for BL (NOTE01: this profile applies to HEVC BL only)
+                                                    #                (NOTE02: When NonHEVCBase is set to 1, this profile & associated level should be updated appropriately)
+Profile2                      : scalable-main       # Scalable profile
 
 #======== Unit definition ================
Index: branches/SHM-upgrade/cfg/encoder_intra_scalable10.cfg
===================================================================
--- branches/SHM-upgrade/cfg/encoder_intra_scalable10.cfg	(revision 989)
+++ branches/SHM-upgrade/cfg/encoder_intra_scalable10.cfg	(revision 992)
@@ -4,7 +4,9 @@
 #======== Profile ================
 NumProfileTierLevel           : 3
-Profile0                      : scalable-main10      #Profile for the whole bitstream
-Profile1                      : main10               #Profile for the base layer --- this will be ignored when BL is not HEVC
-Profile2                      : scalable-main10      #Profile for the enhancement layer
+Profile0                      : main10                # Profile for BL (NOTE01: this profile applies to whole layers but only BL is outputted)
+                                                      #                (NOTE02: this profile has no effect when NonHEVCBase is set to 1)
+Profile1                      : main10                # Profile for BL (NOTE01: this profile applies to HEVC BL only)
+                                                      #                (NOTE02: When NonHEVCBase is set to 1, this profile & associated level should be updated appropriately)
+Profile2                      : scalable-main10       # Scalable profile
 
 #======== Unit definition ================
Index: branches/SHM-upgrade/cfg/encoder_lowdelay_P_scalable.cfg
===================================================================
--- branches/SHM-upgrade/cfg/encoder_lowdelay_P_scalable.cfg	(revision 989)
+++ branches/SHM-upgrade/cfg/encoder_lowdelay_P_scalable.cfg	(revision 992)
@@ -5,7 +5,9 @@
 #======== Profile ================
 NumProfileTierLevel           : 3
-Profile0                      : scalable-main      #Profile for the whole bitstream
-Profile1                      : main               #Profile for the base layer --- this will be ignored when BL is not HEVC
-Profile2                      : scalable-main      #Profile for the enhancement layer
+Profile0                      : main                # Profile for BL (NOTE01: this profile applies to whole layers but only BL is outputted)
+                                                    #                (NOTE02: this profile has no effect when NonHEVCBase is set to 1)
+Profile1                      : main                # Profile for BL (NOTE01: this profile applies to HEVC BL only)
+                                                    #                (NOTE02: When NonHEVCBase is set to 1, this profile & associated level should be updated appropriately)
+Profile2                      : scalable-main       # Scalable profile
 
 #======== Unit definition ================
Index: branches/SHM-upgrade/cfg/encoder_lowdelay_P_scalable10.cfg
===================================================================
--- branches/SHM-upgrade/cfg/encoder_lowdelay_P_scalable10.cfg	(revision 989)
+++ branches/SHM-upgrade/cfg/encoder_lowdelay_P_scalable10.cfg	(revision 992)
@@ -5,7 +5,9 @@
 #======== Profile ================
 NumProfileTierLevel           : 3
-Profile0                      : scalable-main10      #Profile for the whole bitstream
-Profile1                      : main10               #Profile for the base layer --- this will be ignored when BL is not HEVC
-Profile2                      : scalable-main10      #Profile for the enhancement layer
+Profile0                      : main10                # Profile for BL (NOTE01: this profile applies to whole layers but only BL is outputted)
+                                                      #                (NOTE02: this profile has no effect when NonHEVCBase is set to 1)
+Profile1                      : main10                # Profile for BL (NOTE01: this profile applies to HEVC BL only)
+                                                      #                (NOTE02: When NonHEVCBase is set to 1, this profile & associated level should be updated appropriately)
+Profile2                      : scalable-main10       # Scalable profile
 
 #======== Unit definition ================
Index: branches/SHM-upgrade/cfg/encoder_lowdelay_scalable.cfg
===================================================================
--- branches/SHM-upgrade/cfg/encoder_lowdelay_scalable.cfg	(revision 989)
+++ branches/SHM-upgrade/cfg/encoder_lowdelay_scalable.cfg	(revision 992)
@@ -5,7 +5,9 @@
 #======== Profile ================
 NumProfileTierLevel           : 3
-Profile0                      : scalable-main      #Profile for the whole bitstream
-Profile1                      : main               #Profile for the base layer --- this will be ignored when BL is not HEVC
-Profile2                      : scalable-main      #Profile for the enhancement layer
+Profile0                      : main                # Profile for BL (NOTE01: this profile applies to whole layers but only BL is outputted)
+                                                    #                (NOTE02: this profile has no effect when NonHEVCBase is set to 1)
+Profile1                      : main                # Profile for BL (NOTE01: this profile applies to HEVC BL only)
+                                                    #                (NOTE02: When NonHEVCBase is set to 1, this profile & associated level should be updated appropriately)
+Profile2                      : scalable-main       # Scalable profile
 
 #======== Unit definition ================
Index: branches/SHM-upgrade/cfg/encoder_lowdelay_scalable10.cfg
===================================================================
--- branches/SHM-upgrade/cfg/encoder_lowdelay_scalable10.cfg	(revision 989)
+++ branches/SHM-upgrade/cfg/encoder_lowdelay_scalable10.cfg	(revision 992)
@@ -5,7 +5,9 @@
 #======== Profile ================
 NumProfileTierLevel           : 3
-Profile0                      : scalable-main10      #Profile for the whole bitstream
-Profile1                      : main10               #Profile for the base layer --- this will be ignored when BL is not HEVC
-Profile2                      : scalable-main10      #Profile for the enhancement layer
+Profile0                      : main10                # Profile for BL (NOTE01: this profile applies to whole layers but only BL is outputted)
+                                                      #                (NOTE02: this profile has no effect when NonHEVCBase is set to 1)
+Profile1                      : main10                # Profile for BL (NOTE01: this profile applies to HEVC BL only)
+                                                      #                (NOTE02: When NonHEVCBase is set to 1, this profile & associated level should be updated appropriately)
+Profile2                      : scalable-main10       # Scalable profile
 
 #======== Unit definition ================
Index: branches/SHM-upgrade/cfg/encoder_randomaccess_scalable.cfg
===================================================================
--- branches/SHM-upgrade/cfg/encoder_randomaccess_scalable.cfg	(revision 989)
+++ branches/SHM-upgrade/cfg/encoder_randomaccess_scalable.cfg	(revision 992)
@@ -5,7 +5,9 @@
 #======== Profile ================
 NumProfileTierLevel           : 3
-Profile0                      : scalable-main      #Profile for the whole bitstream
-Profile1                      : main               #Profile for the base layer --- this will be ignored when BL is not HEVC
-Profile2                      : scalable-main      #Profile for the enhancement layer
+Profile0                      : main                # Profile for BL (NOTE01: this profile applies to whole layers but only BL is outputted)
+                                                    #                (NOTE02: this profile has no effect when NonHEVCBase is set to 1)
+Profile1                      : main                # Profile for BL (NOTE01: this profile applies to HEVC BL only)
+                                                    #                (NOTE02: When NonHEVCBase is set to 1, this profile & associated level should be updated appropriately)
+Profile2                      : scalable-main       # Scalable profile
 
 #======== Unit definition ================
Index: branches/SHM-upgrade/cfg/encoder_randomaccess_scalable10.cfg
===================================================================
--- branches/SHM-upgrade/cfg/encoder_randomaccess_scalable10.cfg	(revision 989)
+++ branches/SHM-upgrade/cfg/encoder_randomaccess_scalable10.cfg	(revision 992)
@@ -5,7 +5,9 @@
 #======== Profile ================
 NumProfileTierLevel           : 3
-Profile0                      : scalable-main10      #Profile for the whole bitstream
-Profile1                      : main10               #Profile for the base layer --- this will be ignored when BL is not HEVC
-Profile2                      : scalable-main10      #Profile for the enhancement layer
+Profile0                      : main10                # Profile for BL (NOTE01: this profile applies to whole layers but only BL is outputted)
+                                                      #                (NOTE02: this profile has no effect when NonHEVCBase is set to 1)
+Profile1                      : main10                # Profile for BL (NOTE01: this profile applies to HEVC BL only)
+                                                      #                (NOTE02: When NonHEVCBase is set to 1, this profile & associated level should be updated appropriately)
+Profile2                      : scalable-main10       # Scalable profile
 
 #======== Unit definition ================
Index: branches/SHM-upgrade/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/SHM-upgrade/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 989)
+++ branches/SHM-upgrade/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 992)
@@ -3278,4 +3278,12 @@
     ii++;
   }
+  if( m_numLayers > 1 && m_numPTLInfo > 1 && !m_nonHEVCBaseLayerFlag )
+  {
+    assert(m_profileList[0] <= Profile::MULTIVIEWMAIN);  //Profile IDC of PTL in VPS shall be one of single-layer profile IDCs
+    assert(m_profileList[0] == m_profileList[1]);        //Profile IDC of VpsProfileTierLevel[ 0 ] and VpsProfileTierLevel[ 1 ] shall be the same when BL is HEVC compatible
+    assert(m_levelList[0] >= m_levelList[1]);            //Level IDC of VpsProfileTierLevel[ 0 ] should not be less than level IDC of VpsProfileTierLevel[ 1 ]. 
+                                                         //NOTE that this is not conformance constraint but it would be nice if our encoder can prevent inefficient level IDC assignment
+    if (m_levelList[0] == m_levelList[1]) printf("Warning: Level0 is set the same as Level1\n");
+  }
 #else
   if( m_profile==Profile::NONE )